package dev.shadowsoffire.apotheosis.util;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import dev.shadowsoffire.apotheosis.util.ParticleMessage;
import dev.shadowsoffire.placebo.network.MessageHelper;
import dev.shadowsoffire.placebo.network.MessageProvider;
import java.util.Optional;
import java.util.function.Supplier;
import net.minecraft.client.Minecraft;
import net.minecraft.core.particles.ParticleOptions;
import net.minecraft.core.particles.ParticleType;
import net.minecraft.network.FriendlyByteBuf;
import net.minecraftforge.network.NetworkDirection;
import net.minecraftforge.network.NetworkEvent;
import net.minecraftforge.registries.ForgeRegistries;
import net.minecraftforge.registries.ForgeRegistry;

public class Provider implements MessageProvider<ParticleMessage> {
  public Class<ParticleMessage> getMsgClass() {
    return ParticleMessage.class;
  }
  
  public ParticleMessage read(FriendlyByteBuf buf) {
    ParticleType<?> type = (ParticleType)((ForgeRegistry)ForgeRegistries.PARTICLE_TYPES).getValue(buf.readInt());
    double x = buf.readDouble();
    double y = buf.readDouble();
    double z = buf.readDouble();
    double velX = buf.readDouble();
    double velY = buf.readDouble();
    double velZ = buf.readDouble();
    int count = buf.readInt();
    return new ParticleMessage(type, x, y, z, velX, velY, velZ, count);
  }
  
  public void write(ParticleMessage msg, FriendlyByteBuf buf) {
    buf.writeInt(((ForgeRegistry)ForgeRegistries.PARTICLE_TYPES).getID(msg.type));
    buf.writeDouble(msg.x).writeDouble(msg.y).writeDouble(msg.z);
    buf.writeDouble(msg.velX).writeDouble(msg.velY).writeDouble(msg.velZ);
    buf.writeInt(msg.count);
  }
  
  public void handle(ParticleMessage msg, Supplier<NetworkEvent.Context> ctx) {
    MessageHelper.handlePacket(() -> {
          for (int i = 0; i < msg.count; i++)
            (Minecraft.m_91087_()).f_91073_.m_7106_((ParticleOptions)msg.type, msg.x, msg.y, msg.z, msg.velX, msg.velY, msg.velZ); 
        }ctx);
  }
  
  public Optional<NetworkDirection> getNetworkDirection() {
    return Optional.of(NetworkDirection.PLAY_TO_CLIENT);
  }
}
